library ieee;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
library work;
use work.std_logic_arithext.all;


--datapath entity
entity linear is
   port(
      A:in std_logic_vector(3 downto 0);
      B:in std_logic_vector(3 downto 0);
      C:out std_logic_vector(3 downto 0);
      D:out std_logic_vector(3 downto 0);
      rst_n : in std_logic;
      clk : in std_logic

   );
end linear;


--signal declaration
architecture RTL of linear is
signal s_A:std_logic_vector(3 downto 0);
signal s_B:std_logic_vector(3 downto 0);
signal s_C:std_logic_vector(3 downto 0);
signal s_D:std_logic_vector(3 downto 0);
signal sleft_A:std_logic_vector(3 downto 0);
signal sleft_D:std_logic_vector(3 downto 0);
signal sright_A:std_logic_vector(3 downto 0);
signal sright_D:std_logic_vector(3 downto 0);
signal sig_0:std_logic_vector(3 downto 0);
signal sig_1:std_logic_vector(3 downto 0);
signal sig_2:std_logic_vector(3 downto 0);
signal sig_3:std_logic_vector(3 downto 0);
signal sig_4:std_logic_vector(3 downto 0);
signal sig_5:std_logic_vector(3 downto 0);
signal sig_6:std_logic_vector(3 downto 0);
signal sig_7:std_logic_vector(3 downto 0);
signal sig_8:std_logic_vector(3 downto 0);
signal sig_9:std_logic_vector(3 downto 0);
signal C_int:std_logic_vector(3 downto 0);
signal D_int:std_logic_vector(3 downto 0);


begin


   --combinational logics
   dpCMB: process (s_A,s_B,s_C,s_D,sleft_A,sleft_D,sright_A,sright_D,sig_0,sig_1
,sig_2,sig_3,sig_4,sig_5,sig_6,sig_7,sig_8,sig_9,C_int,D_int
,A,B)
      begin
         s_A <= (others=>'0');
         s_B <= (others=>'0');
         s_C <= (others=>'0');
         s_D <= (others=>'0');
         sleft_A <= (others=>'0');
         sleft_D <= (others=>'0');
         sright_A <= (others=>'0');
         sright_D <= (others=>'0');
         sig_0 <= (others=>'0');
         sig_1 <= (others=>'0');
         sig_2 <= (others=>'0');
         sig_3 <= (others=>'0');
         sig_4 <= (others=>'0');
         sig_5 <= (others=>'0');
         sig_6 <= (others=>'0');
         sig_7 <= (others=>'0');
         sig_8 <= (others=>'0');
         sig_9 <= (others=>'0');
         C_int <= (others=>'0');
         D_int <= (others=>'0');
         C <= (others=>'0');
         D <= (others=>'0');

         sig_0 <= s_A(2 downto 0) & s_A(3);
         sleft_A <= sig_0;
         sig_1 <= conv_std_logic_vector(shr(unsigned(A),conv_unsigned(2,4)),4);
         sig_2 <= sig_1 and conv_std_logic_vector(2,4);
         sright_A <= sig_2;
         sig_3 <= s_D(2 downto 0) & s_D(3);
         sleft_D <= sig_3;
         sig_4 <= conv_std_logic_vector(shr(unsigned(D_int),conv_unsigned(2,4)),4);
         sig_5 <= sig_4 and conv_std_logic_vector(2,4);
         sright_D <= sig_5;
         sig_6 <= s_B xor sleft_A;
         sig_7 <= sig_6 xor sright_A;
         s_D <= sig_7;
         sig_8 <= s_A xor sleft_D;
         sig_9 <= sig_8 xor sright_D;
         s_C <= sig_9;
         s_A <= A;
         s_B <= B;
         C <= C_int;
         D <= D_int;
         C_int <= s_C;
         D_int <= s_D;
      end process dpCMB;
end RTL;
